#include <math.h>

/*
 * calculate standard deviation for sequence of integers
 */

void calcstats_int(int num, int *data, double *datamin, double *datamax,
                double *datamean, double *datarms, double *datastddev) {
  double min, max, mean, diff, variance, rms, stddev, scale;
  int i;

  scale = 1.0 / num;

  mean = 0;
  min = data[0];
  max = data[0];
  for (i=0; i<num; i++) {
    if (data[i] < min)
      min = data[i];

    if (data[i] > max) 
      max = data[i];

    mean += data[i];
  }
  mean *= scale; 

  variance = 0;
  rms = 0;
  for (i=0; i<num; i++) {
    double val = data[i];      /* prevent overflow when squaring values */
    diff = val - mean; 
    variance += (diff * diff); 
    rms += val * val;
  }
  variance *= scale;
  rms *= scale;
  rms = sqrt(rms);
  stddev = sqrt(variance);

  *datamin = min;
  *datamax = max;
  *datamean = mean;
  *datarms = rms;
  *datastddev = stddev;
}

