/* 
 * util.h - This file contains defines for the timer functions...
 *
 *  $Id: util.h,v 1.1 2007/09/02 06:42:04 johns Exp $
 */

#if !defined(RT_UTIL_H) 
#define RT_UTIL_H 1

void rt_sleep(int msec);                /* sleep for N msecs */

typedef void * rt_timerhandle;          /* a timer handle */
rt_timerhandle rt_timer_create(void);   /* create a timer (clears timer)  */
void rt_timer_destroy(rt_timerhandle);  /* create a timer (clears timer)  */
void rt_timer_start(rt_timerhandle);    /* start a timer  (clears timer)  */
void rt_timer_stop(rt_timerhandle);     /* stop a timer                   */
float rt_timer_time(rt_timerhandle);    /* report elapsed time in seconds */
float rt_timer_timenow(rt_timerhandle); /* report elapsed time in seconds */

typedef struct {
  double lasttime;
  double updatetime;
} msgtimer;

/* initialize periodic status message timer */
void msg_timer_init(msgtimer *time, double updatetime);

/* return true if it's time to print a status update message */
int msg_timer_timeout(msgtimer *time);

/* countdown timer with user feedback messages */
int countdown(const char *msgformat, float seconds);

/* get UTC date/time string, returns 0 on success, 1 if local time only */
int get_utc_datetime(char *timestr);
int get_utc_time(char *timestr);
int get_utc_secfrac(float *frac);

int strupncmp(const char *, const char *, int);


#endif



